use super::*;
use std::{
    str,
    fmt,
    path::{
	      PathBuf,
	      Path,
    },
};

mod parse;

mod format;
pub use format::*;

mod error;
pub use error::*;

mod job;
pub use job::*;

mod global;
pub use global::*;

/// Parse a single config file
#[inline]
pub async fn parse_global_single(path: impl AsRef<Path>) -> Result<Config, error::Error>
{
    let mut cfg = Config::default();
    parse::global(&mut cfg, path).await?;
    Ok(cfg)
}
